<template>
  <div>
    <h2 id="page-heading" data-cy="EspirometriaHeading">
      <span v-text="$t('gatewayApp.expedientemanualEspirometria.home.title')" id="espirometria-heading">Espirometrias</span>
      <div class="d-flex justify-content-end">
        <button class="btn btn-info mr-2" v-on:click="handleSyncList" :disabled="isFetching">
          <font-awesome-icon icon="sync" :spin="isFetching"></font-awesome-icon>
          <span v-text="$t('gatewayApp.expedientemanualEspirometria.home.refreshListLabel')">Refresh List</span>
        </button>
        <router-link :to="{ name: 'EspirometriaCreate' }" custom v-slot="{ navigate }">
          <button
            @click="navigate"
            id="jh-create-entity"
            data-cy="entityCreateButton"
            class="btn btn-primary jh-create-entity create-espirometria"
          >
            <font-awesome-icon icon="plus"></font-awesome-icon>
            <span v-text="$t('gatewayApp.expedientemanualEspirometria.home.createLabel')"> Create a new Espirometria </span>
          </button>
        </router-link>
      </div>
    </h2>
    <br />
    <div class="alert alert-warning" v-if="!isFetching && espirometrias && espirometrias.length === 0">
      <span v-text="$t('gatewayApp.expedientemanualEspirometria.home.notFound')">No espirometrias found</span>
    </div>
    <div class="table-responsive" v-if="espirometrias && espirometrias.length > 0">
      <table class="table table-striped" aria-describedby="espirometrias">
        <thead>
          <tr>
            <th scope="row" v-on:click="changeOrder('id')">
              <span v-text="$t('global.field.id')">ID</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'id'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('fev1T')">
              <span v-text="$t('gatewayApp.expedientemanualEspirometria.fev1T')">Fev 1 T</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'fev1T'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('fev1R')">
              <span v-text="$t('gatewayApp.expedientemanualEspirometria.fev1R')">Fev 1 R</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'fev1R'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('fvcT')">
              <span v-text="$t('gatewayApp.expedientemanualEspirometria.fvcT')">Fvc T</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'fvcT'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('fvcR')">
              <span v-text="$t('gatewayApp.expedientemanualEspirometria.fvcR')">Fvc R</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'fvcR'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('indiceTP')">
              <span v-text="$t('gatewayApp.expedientemanualEspirometria.indiceTP')">Indice TP</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'indiceTP'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('fechaToma')">
              <span v-text="$t('gatewayApp.expedientemanualEspirometria.fechaToma')">Fecha Toma</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'fechaToma'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('resultado')">
              <span v-text="$t('gatewayApp.expedientemanualEspirometria.resultado')">Resultado</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'resultado'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('user.login')">
              <span v-text="$t('gatewayApp.expedientemanualEspirometria.user')">User</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'user.login'"></jhi-sort-indicator>
            </th>
            <th scope="row"></th>
          </tr>
        </thead>
        <tbody>
          <tr v-for="espirometria in espirometrias" :key="espirometria.id" data-cy="entityTable">
            <td>
              <router-link :to="{ name: 'EspirometriaView', params: { espirometriaId: espirometria.id } }">{{
                espirometria.id
              }}</router-link>
            </td>
            <td>{{ espirometria.fev1T }}</td>
            <td>{{ espirometria.fev1R }}</td>
            <td>{{ espirometria.fvcT }}</td>
            <td>{{ espirometria.fvcR }}</td>
            <td>{{ espirometria.indiceTP }}</td>
            <td>{{ espirometria.fechaToma ? $d(Date.parse(espirometria.fechaToma), 'short') : '' }}</td>
            <td>{{ espirometria.resultado }}</td>
            <td>
              {{ espirometria.user ? espirometria.user.login : '' }}
            </td>
            <td class="text-right">
              <div class="btn-group">
                <router-link :to="{ name: 'EspirometriaView', params: { espirometriaId: espirometria.id } }" custom v-slot="{ navigate }">
                  <button @click="navigate" class="btn btn-info btn-sm details" data-cy="entityDetailsButton">
                    <font-awesome-icon icon="eye"></font-awesome-icon>
                    <span class="d-none d-md-inline" v-text="$t('entity.action.view')">View</span>
                  </button>
                </router-link>
                <router-link :to="{ name: 'EspirometriaEdit', params: { espirometriaId: espirometria.id } }" custom v-slot="{ navigate }">
                  <button @click="navigate" class="btn btn-primary btn-sm edit" data-cy="entityEditButton">
                    <font-awesome-icon icon="pencil-alt"></font-awesome-icon>
                    <span class="d-none d-md-inline" v-text="$t('entity.action.edit')">Edit</span>
                  </button>
                </router-link>
                <b-button
                  v-on:click="prepareRemove(espirometria)"
                  variant="danger"
                  class="btn btn-sm"
                  data-cy="entityDeleteButton"
                  v-b-modal.removeEntity
                >
                  <font-awesome-icon icon="times"></font-awesome-icon>
                  <span class="d-none d-md-inline" v-text="$t('entity.action.delete')">Delete</span>
                </b-button>
              </div>
            </td>
          </tr>
        </tbody>
        <infinite-loading
          ref="infiniteLoading"
          v-if="totalItems > itemsPerPage"
          :identifier="infiniteId"
          slot="append"
          @infinite="loadMore"
          force-use-infinite-wrapper=".el-table__body-wrapper"
          :distance="20"
        >
        </infinite-loading>
      </table>
    </div>
    <b-modal ref="removeEntity" id="removeEntity">
      <span slot="modal-title"
        ><span
          id="gatewayApp.expedientemanualEspirometria.delete.question"
          data-cy="espirometriaDeleteDialogHeading"
          v-text="$t('entity.delete.title')"
          >Confirm delete operation</span
        ></span
      >
      <div class="modal-body">
        <p id="jhi-delete-espirometria-heading" v-text="$t('gatewayApp.expedientemanualEspirometria.delete.question', { id: removeId })">
          Are you sure you want to delete this Espirometria?
        </p>
      </div>
      <div slot="modal-footer">
        <button type="button" class="btn btn-secondary" v-text="$t('entity.action.cancel')" v-on:click="closeDialog()">Cancel</button>
        <button
          type="button"
          class="btn btn-primary"
          id="jhi-confirm-delete-espirometria"
          data-cy="entityConfirmDeleteButton"
          v-text="$t('entity.action.delete')"
          v-on:click="removeEspirometria()"
        >
          Delete
        </button>
      </div>
    </b-modal>
  </div>
</template>

<script lang="ts" src="./espirometria.component.ts"></script>
